
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux vmstat命令实战详解 / iVAN</title>

    <meta name="description" content="Linux vmstat命令实战详解 vmstat命令是最常见的Linux/Unix监控工具,可以展现给定时间间隔的服务器的状态值,包括服务器的CPU使用率,内存使用,虚拟内存交换情况,IO读写情况.这个命令是我查看Linux/Unix最喜爱的命令,一个是Linux/Unix都支持,二是相比top,我可以看到整个机器的CPU,内存,IO的使用情况,而不是单单看到各个进程的CPU使用率和内存使用率(使用场景不一样). 一般vmstat工具的使用是通过两个数字参数来完成的,第一个参数是采样的时间间隔数,单位是秒,第二个参数是采样的次数,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux vmstat命令实战详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>vmstat命令是最常见的Linux/Unix监控工具，可以展现给定时间间隔的服务器的状态值,包括服务器的CPU使用率，内存使用，虚拟内存交换情况,IO读写情况。这个命令是我查看Linux/Unix最喜爱的命令，一个是Linux/Unix都支持，二是相比top，我可以看到整个机器的CPU,内存,IO的使用情况，而不是单单看到各个进程的CPU使用率和内存使用率(使用场景不一样)。</p>
<p>　　一般vmstat工具的使用是通过两个数字参数来完成的，第一个参数是采样的时间间隔数，单位是秒，第二个参数是采样的次数，如:</p>
<p>　　root@ubuntu:~# vmstat 2 1</p>
<p>　　procs -----------memory---------- ---swap-- -----io---- -system-- ----cpu----</p>
<p>　　r  b   swpd   free   buff  cache   si   so    bi    bo   in   cs us sy id wa</p>
<p>　　1  0      0 3498472 315836 3819540    0    0     0     1    2    0  0  0 100  0</p>
<p>　　2表示每个两秒采集一次服务器状态，1表示只采集一次。</p>
<p>　　实际上，在应用过程中，我们会在一段时间内一直监控，不想监控直接结束vmstat就行了,例如:</p>
<table>
<tbody>
<tr>
<td>
<br />root@ubuntu:~# vmstat 2</p>
<p>procs -----------memory---------- ---swap-- -----io---- -system-- ----cpu----</p>
<p>r  b   swpd   free   buff  cache   si   so    bi    bo   in   cs us sy id wa</p>
<p>1  0      0 3499840 315836 3819660    0    0     0     1    2    0  0  0 100  0</p>
<p>0  0      0 3499584 315836 3819660    0    0     0     0   88  158  0  0 100  0</p>
<p>0  0      0 3499708 315836 3819660    0    0     0     2   86  162  0  0 100  0</p>
<p>0  0      0 3499708 315836 3819660    0    0     0    10   81  151  0  0 100  0</p>
<p>1  0      0 3499732 315836 3819660    0    0     0     2   83  154  0  0 100  0
</td>
</tr>
</tbody>
</table>
<p>　　这表示vmstat每2秒采集数据，一直采集，直到我结束程序，这里采集了5次数据我就结束了程序。</p>
<p>　　好了，命令介绍完毕，现在开始实战讲解每个参数的意思。</p>
<p>　　r 表示运行队列(就是说多少个进程真的分配到CPU)，我<a><u><strong>测试</strong></u></a>的服务器目前CPU比较空闲，没什么程序在跑，当这个值超过了CPU数目，就会出现CPU瓶颈了。这个也和top的负载有关系，一般负载超过了3就比较高，超过了5就高，超过了10就不正常了，服务器的状态很危险。top的负载类似每秒的运行队列。如果运行队列过大，表示你的CPU很繁忙，一般会造成CPU使用率很高。</p>
<p>　　b 表示阻塞的进程,这个不多说，进程阻塞，大家懂的。</p>
<p>　　swpd 虚拟内存已使用的大小，如果大于0，表示你的机器物理内存不足了，如果不是程序内存泄露的原因，那么你该升级内存了或者把耗内存的任务迁移到其他机器。</p>
<p>　　free   空闲的物理内存的大小，我的机器内存总共8G，剩余3415M。</p>
<p>　　buff   Linux/Unix系统是用来存储，目录里面有什么内容，权限等的缓存，我本机大概占用300多M</p>
<p>　　cache cache直接用来记忆我们打开的文件,给文件做缓冲，我本机大概占用300多M(这里是Linux/Unix的聪明之处，把空闲的物理内存的一部分拿来做文件和目录的缓存，是为了提高 程序执行的性能，当程序使用内存时，buffer/cached会很快地被使用。)</p>
<p>　　si  每秒从磁盘读入虚拟内存的大小，如果这个值大于0，表示物理内存不够用或者内存泄露了，要查找耗内存进程解决掉。我的机器内存充裕，一切正常。</p>
<p>　　so  每秒虚拟内存写入磁盘的大小，如果这个值大于0，同上。</p>
<p>　　bi  块设备每秒接收的块数量，这里的块设备是指系统上所有的磁盘和其他块设备，默认块大小是1024byte，我本机上没什么IO操作，所以一直是0，但是我曾在处理拷贝大量数据(2-3T)的机器上看过可以达到140000/s，磁盘写入速度差不多140M每秒</p>
<p>　　bo 块设备每秒发送的块数量，例如我们读取文件，bo就要大于0。bi和bo一般都要接近0，不然就是IO过于频繁，需要调整。</p>
<p>　　in 每秒CPU的中断次数，包括时间中断</p>
<p>　　cs 每秒上下文切换次数，例如我们调用系统函数，就要进行上下文切换，线程的切换，也要进程上下文切换，这个值要越小越好，太大了，要考虑调低线程或者进程的数目,例如在apache和nginx这种<a><u><strong>web</strong></u></a>服务器中，我们一般做<a><u><strong>性能测试</strong></u></a>时会进行几千并发甚至几万并发的测试，选择web服务器的进程可以由进程或者线程的峰值一直下调，压测，直到cs到一个比较小的值，这个进程和线程数就是比较合适的值了。系统调用也是，每次调用系统函数，我们的代码就会进入内核空间，导致上下文切换，这个是很耗资源，也要尽量避免频繁调用系统函数。上下文切换次数过多表示你的CPU大部分浪费在上下文切换，导致CPU干正经事的时间少了，CPU没有充分利用，是不可取的。</p>
<p>　　us 用户CPU时间，我曾经在一个做加密解密很频繁的服务器上，可以看到us接近100,r运行队列达到80(机器在做压力测试，性能表现不佳)。</p>
<p>　　sy 系统CPU时间，如果太高，表示系统调用时间长，例如是IO操作频繁。</p>
<p>　　id  空闲 CPU时间，一般来说，id + us + sy = 100,一般我认为id是空闲CPU使用率，us是用户CPU使用率，sy是系统CPU使用率。</p>
<p>　　wt 等待IO CPU时间。</p>
<p>最新内容请见作者的GitHub页：http://qaseven.github.io/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 05:47:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%a3%81%e7%9b%98/" title="磁盘">磁盘</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/cpu/" title="cpu">cpu</a>, <a href="https://www.iamivan.net/tag/unix/" title="Unix">Unix</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux vmstat命令实战详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z432wrp.html" rel="bookmark">Linux netstat命令大全详解&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 Netstat 命令用于显示各种网络相关信息,如网络连接,路由表,接口状态 (Interface Statistics),masquerade 连接,多播成员 (Multicast Memberships) 等等. 输出信息含义 执行netstat后,其输出结果为 Active Internet connections (w/o servers) Proto Recv-Q Send-Q Local Address Foreign Address State tcp 0 2 210.34.6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0xE0p.html" rel="bookmark">Linux vmstat命令实战详细解析&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				vmstat命令是最常见的Linux/Unix监控工具,可以展现给定时间间隔的服务器的状态值,包括服务器的CPU使用率,内存使用,虚拟内存交换情况,IO读写情况.这个命令是我查看Linux/Unix最喜爱的命令,一个是Linux/Unix都支持,二是相比top,我可以看到整个机器的CPU,内存,IO的使用情况,而不是单单看到各个进程的CPU使用率和内存使用率(使用场景不一样). 一般vmstat工具的使用是通过两个数字参数来完成的,第一个参数是采样的时间间隔数,单位是秒,第二个参数是采样的次数,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJeNyqp.html" rel="bookmark">linux ps命令使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux ps命令用于列出当前时刻运行的进程.通过ps命令我们可以知道进程的状态.内存占用.启动时间等等.ps命令部分选项:ps命令输出列字段说明:   字段 说明  %CPU 进程正在使用多少个CPU  %MEM 进程正在使用多少内存 ADDR 进程的内存地址 C或CP CPU使用率和调度信息 COMMAND* 进程名,包括参数(如果有的话) NI nice值 F 标志 PID 进程ID PPID 父进程ID PRI 进程优先级 RSS 真实内存用量 S or STAT 进程状态码进程状态使			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP80Olp.html" rel="bookmark">命令行的艺术&colon;linux bash命令大全详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				熟练使用命令行是一种常常被忽视,或被认为难以掌握的技能,但实际上,它会提高你作为工程师的灵活性以及生产力.本文是一份我在 Linux 上工作时,发现的一些命令行使用技巧的摘要.有些技巧非常基础,而另一些则相当复杂,甚至晦涩难懂.这篇文章并不长,但当你能够熟练掌握这里列出的所有技巧时,你就学会了很多关于命令行的东西了. 这篇文章是 许多作者和译者 共同的成果. 这里的部分内容 首次 出现 于 Quora , 但已经迁移到了 Github,并由众多高手做出了许多改进. 如果你在本文中发现了错误或者存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEl3joz.html" rel="bookmark">Linux fdisk 命令使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  一.fdisk 的介绍 fdisk - Partition table manipulator for Linux ,译成中文的意思是磁盘分区表操作工具;本人译的不太好,也没有看中文文档;其实就是分区工具 fdsik 能划分磁盘成为若干个区,同时也能为每个分区指定分区的文件系统,比如linux .fat32. linux .linux swap .fat16 以及其实类Unix类操作系统的文件系统等;当然我们用fdisk 对磁盘操作分区时,并不是一个终点,我们还要对分区进行格式化所需要的文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6kyBz.html" rel="bookmark">Linux curl命令参数详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  linux curl是通过url语法在命令行下上传或下载文件的工具软件,它支持http,https,ftp,ftps,telnet等多种协议,常被用来抓取网页和监控Web服务器状态. 1. linux curl抓取网页: 抓取百度: curl http://www.baidu.com 如发现乱码,可以使用iconv转码: curl http://if rame.ip138.com/ic.asp|iconv -fgb2312 iconv的用法请参阅:在Linux/Unix系统下用iconv命令			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKn20z.html" rel="bookmark">linux wget 命令用法详解&lpar;附实例说明&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源:http://www.jb51.net/LINUXjishu/86326.html Linux wget是一个下载文件的工具,它用在命令行下.对于Linux用户是必不可少的工具,尤其对于网络管理员,经常要下载一些软件或从远程服务器恢复备份到本地服务器.如果我们使用虚拟主机,处理这样的事务我们只能先从远程服务器下载到我们电脑磁盘,然后再用ftp工具上传到服务器.这样既浪费时间又浪费精力,那不没办法的事.而到了Linux VPS,它则可以直接下载到服务器而不用经过上传这一步.wget工具体积小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN0dGyz.html" rel="bookmark">Linux expect命令用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随处可见的expect 第一次见expect这个命令还是我第一次参加全量上线的时候,那是公司的一个牛人用Shell脚本写的一套自动部署.MD5 比对.发布的全量上线工具,没事的时候,看了下其中的几个脚本,好多的expect命令.实在是看不懂这个expect命令的用法,所以就找时间总结了这篇关于expect命令的文章. 先抛出一个问题 现在有两台Linux主机A和B,如何从A主机ssh到B主机,然后在B主机上执行命令,如何使这个过程实现全程自动化?你可能会使用这种方法: ssh admin@10.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQkgJ0p.html" rel="bookmark">linux fdisk命令使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				fdisk FDISK进行硬盘分区从实质上说就是对硬盘的一种格式化.当我们创建分区时,就已经设置好了硬盘的各项物理参数,指定了硬盘主引导记录(即MasterBootRecord,MBR)和引导记录备份的存放位置.而对于文件系统以及其他操作系统管理硬盘所需要的信息则是通过之后的高级格式化,即Format命令来实现.用一个形象的比喻,分区就好比在一张白纸上画一个大方框.而格式化好比在方框里打上格子.安装各种软件就好比在格子里写上字.分区和格式化就相当于为安装软件打基础,实际上它们为电脑在硬盘上存储数			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9J0Vp.html" rel="bookmark" class="title">Photoshop打造照片的一种空幻效果</a>
					<div>
						原图: 打开原图,复制背景层: 进入通道,点击蓝通道,执行&quot;选择&quot;=&gt;&quot;色彩范围&quot;,用吸管点击蓝天空: 保存选区后,直接用鼠标点击RGB通道 回到图层面板 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLAm0z.html" rel="bookmark" class="title">PHP与XML结合的网站编程</a>
					<div>
						一.小序 HTML简单易学又通用,一般的PHP程序就是嵌入在HTML语言之中实现的.但是随着WEB越来越广泛的应用,HTML的弱点也越来越明显了.XML的出现,弥补了这些不足,它提供了一个能够处理互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mx8KmM.html" rel="bookmark" class="title">信阳SEO：百度不兼容360的SEO思路</a>
					<div>
						近几天腾讯和360对掐的时候百度突然也发出百度不兼容360的信息.这消息一出,让很多人都迷茫了.让所有的人都在疑问.都在反问,百度是怎么不兼容360呢? 难道这是百度想提高知名度?不会.放眼中国,还有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLV5ab.html" rel="bookmark" class="title">为Windows 8和Windows Phone 8构建应用程序</a>
					<div>
						Windows 8 和 Windows Phone 8 趋于融合.与此同时,有志于为这两个平台构建应用程序的开发人 员必须了解两者之间重要的相似之处和不同之处.了解 Windows 8 和 Windo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEadPb.html" rel="bookmark" class="title">SQL Server的&OpenCurlyDoubleQuote;警报&rdquo;应如何解决</a>
					<div>
						问:SQL Server的警报问题应该如何解决? 答:具体的解决方法请参考下文 : 检查你是否使用了最新的Sql Server service pack.因为在最新的Sql Server servic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrX64p.html" rel="bookmark" class="title">QQ场景iSee轻松造</a>
					<div>
						相信很多人都已经会做QQ场景了吧.会做的人不纺在来看一次,我只是教一些正在学习做QQ场景的人.别踢我咬!其实可以作成动态图片的软件有很多,这这里我就不多举了.因为我本人很喜欢isee这个软件,所以这次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7gvWb.html" rel="bookmark" class="title">使用闭包对setTimeout进行简单封装避免出错</a>
					<div>
						在写js脚本时,经常会用到一些拼写函数的情况,例如调用setTimeout 复制代码 代码如下: var msgalert=&quot;test&quot;; function TestAlert(m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKB34p.html" rel="bookmark" class="title">centos系统文本界面启动网卡和修改DNS地址的方法</a>
					<div>
						  win7操作系统,vmware安装centos6.2,为了练习www服务器配置,采用文本界面,一直在考虑一个问题,这个网卡该怎么启动呢?反正现在觉得学习centos比以前顺畅多了.越学越觉得有味道 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1kGnz.html" rel="bookmark" class="title">Firefox如何安装&period;xpi的扩展</a>
					<div>
						Firefox安装.xpi的扩展方法如下: ①把 .xpi文件拖进firefox窗口里,稍后就可以看到Firefox会询问你是否要安装这个扩展,点击&quot;是&quot;,重启浏览器即可. ②Ct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Eq5kM.html" rel="bookmark" class="title">Win7系统不能看到共享文件</a>
					<div>
						  出现以上这种情况,可以根据以下步骤进行设置. 1.在&quot;网络和共享中心&quot;中,单击左侧的&quot;更改高级共享&quot;设置,打开&quot;高级共享设置&quot;,选中&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGB41p.html" rel="bookmark" class="title">电脑中使用窗口模式玩上古卷轴5时出现两个鼠标如何解决</a>
					<div>
						  1.打开一个小窗口或者直接按Ctrl+Alt+Del或Ctrl+Shift+Esc打开任务管理器,使用Alt+Tab快捷键切换窗口; 2.将鼠标置于游戏窗口和桌面的边缘处; 3.不断在游戏窗口和桌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ1YNz.html" rel="bookmark" class="title">软件-求教算法，关于公交车线路问题~</a>
					<div>
						问题描述 求教算法,关于公交车线路问题~ 本人做毕设,做一个JAVA BS的公交车查询软件,现在求解:当涉及到要转车时,怎么操作?数据库表要怎么设计?用什么算法好? 解决方案 公交线路相当于一个图.而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEPkmz.html" rel="bookmark" class="title">关于c&num;静态方法和实例方法的辨析和应用</a>
					<div>
						本文将围绕c#静态方法和实例方法讨论一下.针对一些观点,如:&quot;静态方法是常驻内存&quot;, 还有&quot;静态方法比实例方法先装载&quot;,做一个辨析.同时讨论下何时用静态方法,何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6WN0b.html" rel="bookmark" class="title">《产品经理的20堂必修课》学习笔记</a>
					<div>
						      豆瓣&lt;产品经理的20堂必修课&gt;   第1章 从用户需求出发 产品是否能够获得市场上用户的认可,根本上是由产品的功能所满足的用户需求所决定的,而不是我们认为的产品的功能决定的.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAWKvM.html" rel="bookmark" class="title">让UserControl可以被验证</a>
					<div>
						在web开发中,我们通常会将重复使用的代码分装成UserControl,方便之后reuse,例如DateTime控件.HtmlEditor等. MS为asp.net 提供了一种简单的验证机制.本文要说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7Z1Az.html" rel="bookmark" class="title">WINDOWS下，中文JSON格式读取报错处理：ValueError&colon; No JSON object could be decoded</a>
					<div>
						  File &quot;C:\Python27\lib\json\__init__.py&quot;, line 290, in load **kw) File &quot;C:\Python27\ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRRAVb.html" rel="bookmark" class="title">泛型，IEnumerable接口 ，处理遍历的问题。</a>
					<div>
						问题描述 有这么一个题目,关于树形遍历的问题,我不太理解泛型,IEnumerable&lt;T&gt;,IEnumerable接口在其中的作用,以及能做什么不知道可否讲解一下,这个题的思路,以及大致的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z405jJz.html" rel="bookmark" class="title">java-unicode編碼，換行，行結束</a>
					<div>
						问题描述 unicode編碼,換行,行結束 U+000A:換行符 U+000D:回車符 U+2029:段落結束 U+2028:行結束 這些符號,有沒有語義重複的? 解决方案 UNICODE编码					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eyNYb.html" rel="bookmark" class="title">关于HttpWebResponse&period;GetResponse&lpar;&rpar; 基础连接已经关闭&lpar;连接被意外关闭的问题&rpar;</a>
					<div>
						问题描述 执行WebResponseresponse=http.GetResponse();的时候就会抛异常,异常如下图所示看了看http对象的状态如下图所示大家有没有出现类似的情况呢,麻烦帮忙想一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEXjZM.html" rel="bookmark" class="title">互联网内容的广告模式到底有什么问题</a>
					<div>
						早在去年12月的时候,就有记者总结了一个有关在线广告最重要的问题:广告投放最终花在了购买人们的时间上,这究竟是否是一个&quot;谬论&quot;? 这位记者写到,&quot;如果说人们的注意力时间是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ4Rkp.html" rel="bookmark" class="title">请问怎么将String类型字符串转换为date类型。要求是yyyy-MM-dd  HH&colon;mm&colon;ss 格式的时间类型，以便于以datetime格式存入数据库</a>
					<div>
						问题描述 请问怎么将String类型字符串转换为date类型.要求是yyyy-MM-dd HH:mm:ss 格式的时间类型,以便于以datetime格式存入数据库? 问题补充:非常感谢,嗯,对的,反正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn3Z5M.html" rel="bookmark" class="title">link环境下如何根据文件上传时间计算文件有效期，使用codefirst技术制作《网盘软件》</a>
					<div>
						问题描述 link环境下如何根据文件上传时间计算文件有效期,使用codefirst技术制作&lt;网盘软件&gt; link环境下如何根据文件上传时间计算文件有效期,使用codefirst技术制作&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjX5KM.html" rel="bookmark" class="title">JDK1&period;8源码分析之HashMap（一） &lpar;转&rpar;</a>
					<div>
						一.前言 在分析jdk1.8后的HashMap源码时,发现网上好多分析都是基于之前的jdk,而Java8的HashMap对之前做了较大的优化,其中最重要的一个优化就是桶中的元素不再唯一按照链表组合,也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2kGvM.html" rel="bookmark" class="title">美呀呀鲜花获风投：上海鲜花速递业首家VC投资电商</a>
					<div>
						伴随着我国电子商务崛起和网购消费者的年轻化,网上鲜花速递行业风生水起,目前全国有大大小小的鲜花速递网站1万多家,市场份额超过百亿,网购鲜花已经成为都市时尚一族传递情感的新选择.日前,记者走进70.80 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvlNmM.html" rel="bookmark" class="title">spcrv函数-matlab曲线平滑问题，使曲线部分变得更加平滑</a>
					<div>
						问题描述 matlab曲线平滑问题,使曲线部分变得更加平滑 怎样将图片中曲线进行平滑,尤其是对于红色蓝色交界处的平滑,我用 spcrv函数实现有点困难,有没有别的方法,或者spcrv函数使用有没有什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Y6qnp.html" rel="bookmark" class="title">CentOS 7 安装MySQL 5&period;6遇到的疑难杂症小结</a>
					<div>
						在一测试服务器(CentOS Linux release 7.2.1511)上安装MySQL 5.6(5.6.19 MySQL Community Server)时遇到下面错误,这个是因为CentOS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByxmkz.html" rel="bookmark" class="title">Sogou Rank与网页排名关系</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近对网站和域名的综合权威度或重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqyDNb.html" rel="bookmark" class="title">大数据时代促成&OpenCurlyDoubleQuote;三马&rdquo;复旦聚首</a>
					<div>
						本周显然又有惊喜发生,记者近期一直追踪的众安保险官方微博继上周四发出&quot;11.6,上海,众安保险将有大事发生&quot;的博文引发舆论热议后,周一晚,众安在其官方微博中正式发布&quot;11 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Nordp.html" rel="bookmark" class="title">竞价推广后台如何管理</a>
					<div>
						首先,我们在百度竞价维护时,后台要建立很多计划,这样就可以建一些比较有条理的计划,根据这些计划,你可以来推广网站不同的项目.不同的项目要分到不同的计划里,以免混乱. 其次,我们要设定单元,每个计划都有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOkadxz.html" rel="bookmark" class="title">关于TDD开发模式</a>
					<div>
						问题描述 小弟最近正在研究TDD,上网浏览了很多这方面的资料,这种开发模式优点很多,也很好,但这种打破常规的开发模式在现在的企业中用的多吗,会有很多程序员应这种开发模式吗?毕竟它是耗时的,而客户是不会 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
